require "math"

--J[lvZ
function RGBtoINT(r,g,b)
	return r*256*256 + g*256 + b
end

--w`bv^[Qbgւ̕xNgƂ̒xNg
--id:w`bvԍAtx,ty,tz:^[QbgW
function TgtVector(id,tx,ty,tz)
	
	x = _X(id)
	y = _Y(id)
	z = _Z(id)
	
	tzx = tx-x
	tzy = ty-y
	tzz = tz-z
	
	tmp = math.len3(tzx,tzy,tzz)
	tzx = tzx/tmp
	tzy = tzy/tmp
	tzz = tzz/tmp
	
	tmp = -math.sgn(tzy) * math.len2(tzx,tzz) / math.abs(tzy)
	
	tyx = tzx / tmp
	tyy = math.len2(tzx,tzz)
	tyz = tzz / tmp
	
	tmp = math.atan2(tzx,tzz)-math.pi/2
	
	txx = math.sin(tmp)
	txy = 0
	txz = math.cos(tmp)
	
	return txx,txy,txz,tyx,tyy,tyz,tzx,tzy,tzz
	
end

--w`bv^[Qbg֌`
--id:w`bvԍApos:w`bvƖ̋
--size:̑傫Acolor:̐F
--tx,ty,tz:^[QbgW
function AllowTgt(id,pos,size,color,tx,ty,tz)

	x = _X(id)
	y = _Y(id)
	z = _Z(id)
	
	txx,txy,txz,tyx,tyy,tyz,tzx,tzy,tzz = TgtVector(id,tx,ty,tz)
	
	x = x + tzx*pos
	y = y + tzy*pos
	z = z + tzz*pos
	
	txx,txy,txz,tyx,tyy,tyz,tzx,tzy,tzz = size*txx,size*txy,size*txz,size*tyx,size*tyy,size*tyz,size*tzx,size*tzy,size*tzz
	
	alx = x+tzx*5
	aly = y+tzy*5
	alz = z+tzz*5
	
	--lpʕ`
	dummy=_SETCOLOR(RGBtoINT(255,255,255))
	dummy=_MOVE3D(x+tyx,y+tyy,z+tyz)
	dummy=_LINE3D(x+txx,y+txy,z+txz)
	dummy=_LINE3D(x-tyx,y-tyy,z-tyz)
	dummy=_LINE3D(x-txx,y-txy,z-txz)
	dummy=_LINE3D(x+tyx,y+tyy,z+tyz)
	dummy=_LINE3D(x,y,z)
	
	--[`
	dummy=_SETCOLOR(color)
	dummy=_MOVE3D(x+txx,y+txy,z+txz)
	dummy=_LINE3D(alx,aly,alz)
	dummy=_LINE3D(x-txx,y-txy,z-txz)
	dummy=_MOVE3D(x-tyx,y-tyy,z-tyz)
	dummy=_LINE3D(alx,aly,alz)
	dummy=_LINE3D(x+tyx,y+tyy,z+tyz)
	
end
